-------------------------------------------
--- Author: Ketho (EU-Boulderfist)		---
--- Created: 2011.05.27					---
--- License: Public Domain				---
-------------------------------------------
--- kInstanceTimer	v0.29  [2011.10.09]	---
--- Ace3			r1032  [2011.06.29]	---
-------------------------------------------
--- Curse			http://wow.curse.com/downloads/wow-addons/details/kinstancetimer.aspx
--- WoWInterface	http://www.wowinterface.com/downloads/info19910-kInstanceTimer.html

kInstanceTimer = LibStub("AceAddon-3.0"):NewAddon("kInstanceTimer", "AceEvent-3.0", "AceTimer-3.0", "AceConsole-3.0", "LibSink-2.0")
local KIT = kInstanceTimer
local ACR = LibStub("AceConfigRegistry-3.0")
local ACD = LibStub("AceConfigDialog-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("kInstanceTimer", true)
local LDB = LibStub("LibDataBroker-1.1")

	----------------
	--- Upvalues ---
	----------------

local VERSION = 0.29
local _G = _G
--# Lua APIs
local select = select
local tonumber = tonumber
local floor, mod = floor, mod
local date, time = date, time
local format, gsub = format, gsub 

--# WoW APIs
local GetRealZoneText = GetRealZoneText
local GetBattlefieldInstanceRunTime = GetBattlefieldInstanceRunTime

-- table reference shortcuts
local profile, char

local D_SECONDS = strlower(D_SECONDS)
local D_MINUTES = strlower(D_MINUTES)
local D_HOURS = strlower(D_HOURS)
local D_DAYS = strlower(D_DAYS)

if GetLocale() == "deDE" then
	D_SECONDS = _G.D_SECONDS
	D_MINUTES = _G.D_MINUTES
	D_HOURS = _G.D_HOURS
	D_DAYS = _G.D_DAYS
end

local bttn = CreateFrame("Button")
local D_MINUTES2 = gsub(D_MINUTES, "%%d", "%%.1f") -- integer -> float
local MINUTES1 = gsub(bttn:GetText(bttn:SetFormattedText(D_MINUTES, 2)), "2 ", "") -- plural minutes
local MINUTES2 = gsub(bttn:GetText(bttn:SetFormattedText(_G.D_MINUTES, 2)), "2 ", "")

-- other
local optionsFrame
local cropped = ":64:64:4:60:4:60"
local timeInstance2
local lastTimeInst, lastTimeBG
local prevInst

local BossIDs = { -- Instance Timer
--	[01-60] Classic
	[1853] = true, -- Darkmaster Gandling; Scholomance
	[2748] = true, -- Archaedas; Uldaman
	[3975] = true, -- Herod; Scarlet Monastery: Armory
	[3977] = true, -- High Inquisitor Whitemane; Scarlet Monastery: Cathedral
	[3654] = true, -- Mutanus the Devourer; Wailing Caverns
	[4275] = true, -- Archmage Arugal; Shadowfang Keep (Normal/Heroic)
	[4421] = true, -- Charlga Razorflank; Razorfen Kraul
	[4543] = true, -- Bloodmage Thalnos; Scarlet Monastery: Graveyard
	[4829] = true, -- Aku'mai; Blackfathom Deeps
	[5709] = true, -- Shade of Eranikus; Sunken Temple
	[6487] = true, -- Arcanist Doan; Scarlet Monastery: Library
	[7267] = true, -- Chief Ukorz Sandscalp; Zul'Farrak
	[7358] = true, -- Amnennar the Coldbringer; Razorfen Downs
	[7800] = true, -- Mekgineer Thermaplugg; Gnomeregan
	[9018] = true, -- High Interrogator Gerstahn; Blackrock Depths: Prison
	[9019] = true, -- Emperor Dagran Thaurissan; Blackrock Depths: Upper City
	[9568] = true, -- Overlord Wyrmthalak; Lower Blackrock Spire
	[10813] = true, -- Balnazzar; Stratholme: Main Gate
	[11486] = true, -- Prince Tortheldrin; Dire Maul: Capital Gardens
	[11492] = true, -- Alzzin the Wildshaper; Dire Maul: Warpwood Quarter
	[11501] = true, -- King Gordok; Dire Maul: Gordok Commons
	[11520] = true, -- Taragaman the Hungerer; Ragefire Chasm
	[12201] = true, -- Princess Theradras; Maraudon: Earth Song Falls
	[12236] = true, -- Lord Vyletongue; Maraudon: The Wicked Grotto
	[12258] = true, -- Razorlash; Maraudon: Foulspore Cavern
	[45412] = true, -- Lord Aurius Rivendare; Stratholme - Service Entrance
	[46964] = true, -- Lord Godfrey; Shadowfang Keep
	[46254] = true, -- Hogger; Stormwind Stockade
	[47739] = true, -- "Captain" Cookie; Deadmines (Normal)
	[49541] = true, -- Vanessa VanCleef; Deadmines (Heroic)
--	[60-70] The Burning Crusade
	[16808] = true, -- Warchief Kargath Bladefist; Hellfire Citadel: The Shattered Halls
	[17377] = true, -- Keli'dan the Breaker; Hellfire Citadel: The Blood Furnace
--	[17536] = true, -- [Old] Nazan; Hellfire Citadel: Hellfire Ramparts
	[17307] = true, -- Nazan; Hellfire Citadel: Hellfire Ramparts
	[17798] = true, -- Warlord Kalithresh; Coilfang Reservoir: The Steamvault
	[17881] = true, -- Aeonus; Caverns of Time: The Black Morass
	[17882] = true, -- The Black Stalker; Coilfang Reservoir: The Underbog
	[17942] = true, -- Quagmirran; Coilfang Reservoir: The Slave Pens
	[17977] = true, -- Warp Splinter; Tempest Keep: The Botanica
	[18344] = true, -- Nexus-Prince Shaffar; Auchindoun: Mana-Tombs
	[18373] = true, -- Exarch Maladaar; Auchindoun: Auchenai Crypts
	[18473] = true, -- Talon King Ikiss; Auchindoun: Sethekk Halls
	[18708] = true, -- Murmur; Auchindoun: Shadow Labyrinth
	[18096] = true, -- Epoch Hunter; Caverns of Time: Old Hillsbrad Foothills
	[19220] = true, -- Pathaleon the Calculator; Tempest Keep: The Mechanar
	[20912] = true, -- Harbinger Skyriss; Tempest Keep: The Arcatraz
--	[70-80] Wrath of the Lich King
	[26632] = true, -- The Prophet Tharon'ja; Drak'Tharon Keep (name has an extra space at the end when transformed] = true, GUID remains unchanged though)
	[26723] = true, -- Keristrasza; The Nexus: The Nexus
	[26861] = true, -- King Ymiron; Utgarde Keep: Utgarde Pinnacle
	[27656] = true, -- Ley-Guardian Eregos; The Nexus: The Oculus
	[27978] = true, -- Sjonnir The Ironshaper; Ulduar: Halls of Stone
	[28923] = true, -- Loken; Ulduar: Halls of Lightning
	[29120] = true, -- Anub'arak; Azjol-Nerub: Azjol-Nerub
	[29306] = true, -- Gal'darah; Gundrak
	[29311] = true, -- Herald Volazj; Azjol-Nerub: Ahn'kahet: The Old Kingdom
	[31134] = true, -- Cyanigosa; The Violet Hold
	[36502] = true, -- Devourer of Souls; Icecrown Citadel: The Forge of Souls
	[36658] = true, -- Scourgelord Tyrannus; Icecrown Citadel: Pit of Saron
--	[23954] = true, -- Ingvar the Plunderer; Utgarde Keep: Utgarde Pinnacle (dies 2x)
--	[26533] = true, -- Mal'Ganis; Caverns of Time: The Culling of Stratholme (no death)
--	[35451] = true, -- The Black Knight; Crusaders' Coliseum: Trial of the Champion (dies 3x)
--	[36954] = true, -- The Lich King; Icecrown Citadel: Halls of Reflection (no death)
--	[80-85] Cataclysm
	[39705] = true, -- Ascendant Lord Obsidius; Blackrock Caverns
	[39378] = true, -- Rajh; Halls of Origination
	[40484] = true, -- Erudax; Grim Batol
	[42333] = true, -- High Priestess Azil; The Stonecore
	[43875] = true, -- Asaad; The Vortex Pinnacle
--	[44566] = true, -- Ozumat; Throne of the Tides [no death; 1hp]
	[44819] = true, -- Siamat; Lost City of the Tol'vir
	[52148] = true, -- Jin'do the Godbreaker; Zul'Gurub (does he actually die?)
--	[52150] = true, -- Jin'do the Godbreaker; Zul'Gurub (the phase 2 version)
	[23863] = true, -- Daakara; Zul'Aman
}

local RaidBossIDs = { -- untested
	[52363] = true, -- Occu'thar; Baradin Hold
	[43324] = true, -- Cho'gall; The Bastion of Twilight
	[41376] = true, -- Nefarian; Blackwing Descent
	[46753] = true, -- Al'Akir; Throne of the Four Winds
	[52409] = true, -- Ragnaros; Firelands
}

local SubZoneBossIDs = {
	-- Scarlet Monastery
	[4543] = L["Graveyard"], -- [27-37?] Bloodmage Thalnos
	[6487] = L["Library"], -- [30-40?] Arcanist Doan
	[3975] = L["Armory"], -- [32-42?] Herod
	[3977] = L["Cathedral"], -- [35-45] High Inquisitor Whitemane
	-- Maraudon
	[12236] = L["The Wicked Grotto"], -- [39-49?] Lord Vyletongue
	[12258] = L["Foulspore Cavern"], -- [41-51?] Razorlash
	[12201] = L["Earth Song Falls"], -- [34-44] Princess Theradras
	-- Blackrock Depths
	[9018] = L["Detention Block"], -- [47-57] High Interrogator Gerstahn
	[9019] = L["Upper City"], -- [51-61] Emperor Dagran Thaurissan
	-- Dire Maul
	[11492] = L["Warpwood Quarter"], -- [36-46] Alzzin the Wildshaper
	[11486] = L["Capital Gardens"], -- [39-49] Prince Tortheldrin
	[11501] = L["Gordok Commons"], -- [42-52] King Gordok
	-- Stratholme
	[10813] = L["Main Gate"], -- [42-52] Balnazzar
	[45412] = L["Service Entrance"], -- [46-56] Lord Aurius Rivendare
}

local preBossIDs = {
	[12236] = true, -- Lord Vyletongue
	[12258] = true, -- Razorlash
	[9018] = true, -- High Interrogator Gerstahn
	[10813] = true, -- Balnazzar
}

local finalBossIDs = {
	[12201] = true, -- Princess Theradras
	[9019] = true, -- Emperor Dagran Thaurissan
	[45412] = true, -- Lord Aurius Rivendare
}

	--------------------------
	--- Options & Defaults ---
	--------------------------

local defaults = {
	profile = {
		Instance = true,
		instanceTimerMsg = L["instanceTimerMsg"],
		timeFormat = 2,
		RecordInstance = true,
		sink20OutputSink = "Channel",
		sink20ScrollArea = GROUP,
	},
	-- dont know the proper way for this (=.=)
	char = {
		timeInstance = 0,
		timeInstanceStart = "",
		timeInstanceStart2 = "",
	},
}

local options = {
	type = "group",
	name = "",
	args = {
		Main = {
			type = "group",
			name = "|TInterface\\Icons\\Spell_Holy_BorrowedTime:16:16:3:0"..cropped.."|t  |cffADFF2Fk|r|cffFFFFFFInstanceTimer|r |cffB6CA00v"..VERSION.."|r",
			args = {
				Instance = {
					type = "toggle",
					order = 1,
					descStyle = "",
					width = "full",
					name = " |cffA8A8FF"..L["Instance Timer"].."|r",
					get = function(i) return profile.Instance end,
					set = function(i, v) profile.Instance = v end,
				},
				Raid = {
					type = "toggle",
					order = 2,
					descStyle = "",
					width = "full",
					name = " |cffFF7F00"..RAID.." "..L["Instance Timer"].."|r",
					get = function(i) return profile.Raid end,
					set = function(i, v) profile.Raid = v end,
				},
				Stopwatch = {
					type = "group",
					name = " "..STOPWATCH_TITLE,
					order = 3,
					inline = true,
					args = {
						InstanceStopwatch = {
							type = "toggle",
							order = 1,
							descStyle = "",
							width = "full",
							name = " "..INSTANCE,
							get = function(i) return profile.InstanceStopwatch end,
							set = function(i, v) profile.InstanceStopwatch = v end,
						},
						RaidStopwatch = {
							type = "toggle",
							order = 2,
							descStyle = "",
							width = "full",
							name = " "..RAID,
							get = function(i) return profile.RaidStopwatch end,
							set = function(i, v) profile.RaidStopwatch = v end,
						},
						BattlegroundStopwatch = {
							type = "toggle",
							order = 3,
							descStyle = "",
							width = "full",
							name = " "..BATTLEGROUND,
							get = function(i) return profile.BattlegroundStopwatch end,
							set = function(i, v) profile.BattlegroundStopwatch = v end,
						},
					},
				},
				inputInstanceTimerMsg = {
					type = "input",
					order = 4,
					width = "full",
					name = " ",
					usage = "\n|cff58ACFA[INSTANCE]|r |cffFFFFFF= Instance|r\n|cff71D5FF[TIME]|r |cffFFFFFF= Time|r\n|cffADFF2F[START]|r |cffFFFFFF= Start Time|r\n|cffF6ADC6[END]|r |cffFFFFFF= End Time|r\n|cff0070DD[DATE]|r |cffFFFFFF= MM/DD/YY|r\n|cff0070DD[DATE2]|r |cffFFFFFF= YYYY.MM.DD|r",
					get = function(i) return profile.instanceTimerMsg end,
					set = function(i, v) profile.instanceTimerMsg = v
						if #strtrim(v) == 0 then profile.instanceTimerMsg = defaults.profile.instanceTimerMsg end end,
				},
				descriptionExample = {
					type = "description",
					order = 5,
					name = function() return "   "..KIT:ReplaceTextI(profile.instanceTimerMsg, nil, true) end,
				},
				spacing1 = {
					type = "description",
					order = 6,
					name = "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n",
				},
				RecordInstance = {
					type = "toggle",
					order = 7,
					descStyle = "",
					width = "full",
					name = " Record "..INSTANCE,
					get = function(i) return profile.RecordInstance end,
					set = function(i, v) profile.RecordInstance = v end,
				},
				executePrintInstanceTimer = {
					type = "execute",
					order = 8,
					descStyle = "",
					name = "|TInterface\\Icons\\INV_Misc_Note_01:16:16:1:-1"..cropped.."|t |cffFFFFFFInstance Data|r",
					func = function()
						if char.timeInstanceList then
							local t, i = {}, 1
							for k, v in pairs(char.timeInstanceList) do
								t[i] = k
								i = i + 1
							end
							sort(t)
							for i = 1, #t do
								print(t[i].." "..char.timeInstanceList[t[i]])
							end
						end
					end,
					disabled = function() return not profile.RecordInstance end,
				},
				newline = {type = "description", order = 9, name = ""},
				selectTimeFormat = {
					type = "select",
					order = 10,
					descStyle = "",
					name = "   |cffFFFFFFTime Format|r (|cff71D5FF"..MINUTES2.."|r)",
					values = {"|cffB6CA00X|r minutes, |cffF6ADC6Y|r seconds", "|cffB6CA00X|r.|cffF6ADC6Y|r minutes"},
					get = function(i) return profile.timeFormat end,
					set = function(i, v) profile.timeFormat = v end,
				},
			},
		},
	},
}

local function TimetoMilitaryTime(value)
	local seconds = mod(floor(value), 60)
	local minutes = mod(floor(value/60), 60)
	local hours = floor(value/3600)

	if hours > 0 then
		return format("%s:%02.f:%02.f", hours, minutes, seconds)
	else
		return format("%02.f:%02.f", minutes, seconds)
	end
end

	-------------------------------
	---- OnInitialize, OnEnable ---
	-------------------------------
	
function KIT:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("kInstanceTimerDB", defaults, true)

	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
	self:RefreshConfig()

	self.db.global.version = VERSION
	self.db.global.fileType = "Release"

	ACR:RegisterOptionsTable("kInstanceTimer_Main", options.args.Main)
	ACR:RegisterOptionsTable("kInstanceTimer_LibSink", self:GetSinkAce3OptionsDataTable())
	ACR:RegisterOptionsTable("kInstanceTimer_Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))
	optionsFrame = ACD:AddToBlizOptions("kInstanceTimer_Main", "kInstanceTimer")
	ACD:AddToBlizOptions("kInstanceTimer_LibSink", "|TINTERFACE\\ICONS\\inv_scroll_03:16:16:1:0"..cropped.."|t  LibSink", "kInstanceTimer")
	ACD:AddToBlizOptions("kInstanceTimer_Profiles", "|TInterface\\Icons\\INV_Misc_Note_01:16:16:1:0"..cropped.."|t  Profiles", "kInstanceTimer")

	self:RegisterChatCommand("kit", "SlashCommand")
	self:RegisterChatCommand("kinstance", "SlashCommand")
	self:RegisterChatCommand("kinstancetimer", "SlashCommand")

	char.timeInstanceList = char.timeInstanceList or {}
	
	---------------------
	--- LibDataBroker ---
	---------------------

	local dataobject = {
		type = "data source",
		icon = "Interface\\Icons\\Spell_Holy_BorrowedTime",
		OnClick = function(clickedframe, button)
			if InterfaceOptionsFrame:IsShown() and InterfaceOptionsFramePanelContainer.displayedPanel.name == "kInstanceTimer" then
				InterfaceOptionsFrame:Hide()
			else
				InterfaceOptionsFrame_OpenToCategory(optionsFrame)
			end
		end,
		OnTooltipShow = function(tt)
			tt:AddLine("|cffADFF2FkInstanceTimer|r")
			tt:AddDoubleLine("Instance Time", "|cffFFFFFF"..TimetoMilitaryTime(char.timeInstance > 0 and time() - (timeInstance2 or char.timeInstance) or 0).."|r")
			tt:AddLine("|cffFFFFFFClick|r to open the options menu")
		end,
	}

	self:ScheduleRepeatingTimer(function()
		local runTime = GetBattlefieldInstanceRunTime()
		if runTime > 0 then
			dataobject.text = TimetoMilitaryTime(lastTimeBG and lastTimeBG or runTime/1000)
		elseif lastTimeInst or char.timeInstance > 0 then
			dataobject.text = TimetoMilitaryTime(lastTimeInst and lastTimeInst or (time() - (timeInstance2 or char.timeInstance)))
		else
			dataobject.text = TimetoMilitaryTime(0)
		end
	end, 1)

	LDB:NewDataObject("kInstanceTimer", dataobject)
end

function KIT:OnEnable()
	self:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("CHAT_MSG_SYSTEM")

	-- fallback/secondary events
	self:RegisterEvent("LFG_PROPOSAL_SUCCEEDED")
	self:RegisterEvent("LFG_COMPLETION_REWARD")

	-- reset if not in a party
	-- e.g. player was kicked after a DC
	if GetNumPartyMembers() == 0 then
		char.timeInstance, timeInstance2 = 0, nil
	end
end

	--------------------------
	--- Callback Functions ---
	--------------------------
	
function KIT:RefreshConfig()
	profile, char = self.db.profile, self.db.char
	-- LibSink
	self:SetSinkStorage(profile)
end

function KIT:SlashCommand()
	InterfaceOptionsFrame_OpenToCategory(optionsFrame)
end

function KIT:TimetoString(value)
	local seconds = mod(floor(value), 60)
	local minutes = mod(floor(value/60), 60)
	local hours = floor(value/3600)
	
	local fseconds = bttn:GetText(bttn:SetFormattedText(D_SECONDS, seconds))
	local fminutes = bttn:GetText(bttn:SetFormattedText(D_MINUTES, minutes))
	local fhours = bttn:GetText(bttn:SetFormattedText(D_HOURS, hours))

	if value >= 3600 then
		return minutes > 0 and format("%s, %s", fhours, fminutes) or fhours
	elseif value >= 60 then
		if seconds >= 6 then
			if profile.timeFormat == 1 then
				return format("%s, %s", fminutes, fseconds)
			else
				local xseconds = floor(seconds/6)
				if xseconds == 1 then
					-- problem: incorrectly returned as "x.1 minute"
					return format("%s.%s %s", minutes, xseconds, MINUTES1)
				else
					return bttn:GetText(bttn:SetFormattedText(D_MINUTES2, minutes.."."..xseconds))
				end
			end
		else
			return fminutes
		end
	elseif value >= 0 then
		return fseconds
	else
		return "ERROR: "..value
	end
end

local RAID_CLASS_COLORS = RAID_CLASS_COLORS

local function GetClassColor(class)
	return format("%02X%02X%02X", RAID_CLASS_COLORS[class].r*255, RAID_CLASS_COLORS[class].g*255, RAID_CLASS_COLORS[class].b*255)
end

function KIT:AnnounceInstance(subZone)
	self:Pour(self:ReplaceTextI(profile.instanceTimerMsg, subZone))
end

local party = {}

-- Save Instance Timer data
function KIT:RecordInstance(subZone)
	subZone = subZone and ": "..subZone.."]" or "]"
	wipe(party)
	for i = 1, GetNumPartyMembers() do
		party[i] = format("|cff%s%s|r", GetClassColor(select(2, UnitClass("party"..i))), UnitName("party"..i))
	end
	char.timeInstanceList[format("%s-|cff71D5FF[%s]|r", char.timeInstanceStart2, date("%H:%M"))] = format("|cffADFF2F[%s%s|r in |cff71D5FF%s.|r %s", GetRealZoneText(), subZone, self:TimetoString(time() - char.timeInstance), strjoin(", ", unpack(party)))
end

function KIT:ReplaceTextI(msg, subZone, isExample)
	local gsub = gsub

	if not msg then return "[ERROR] No Message" end

	if isExample then
		local instanceType = select(2, IsInInstance())
		msg = gsub(msg, "%[[Ii][Nn][Ss][Tt][Aa][Nn][Cc][Ee]%]", instanceType == "party" and "|cffA8A8FF"..GetRealZoneText().."|r" or "|cffA8A8FFDeadmines|r")
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", instanceType == "party" and "|cff71D5FF"..(self:TimetoString(time()-(char.timeInstance > 0 and char.timeInstance or time()))).."|r" or "|cff71D5FF"..self:TimetoString(1530).."|r")
		msg = gsub(msg, "%[[Ss][Tt][Aa][Rr][Tt]%]", instanceType == "party" and "|cffF6ADC6"..(char.timeInstance > 0  and char.timeInstanceStart or date("%H:%M")).."|r" or "|cffF6ADC614:27|r")
		msg = gsub(msg, "%[[Ee][Nn][Dd]%]", instanceType == "party" and "|cffADFF2F"..date("%H:%M").."|r" or "|cffADFF2F14:52|r")
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]%]", "|cff0070DD"..date("%m/%d/%y").."|r")
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]2%]", "|cff0070DD"..date("%Y.%m.%d").."|r")
	else
		if subZone then subZone = ": "..subZone else subZone = "" end
		msg = gsub(msg, "%[[Ii][Nn][Ss][Tt][Aa][Nn][Cc][Ee]%]", GetRealZoneText()..subZone)
		msg = gsub(msg, "%[[Tt][Ii][Mm][Ee]%]", self:TimetoString(time() - (timeInstance2 or char.timeInstance)))
		msg = gsub(msg, "%[[Ss][Tt][Aa][Rr][Tt]%]", char.timeInstanceStart)
		msg = gsub(msg, "%[[Ee][Nn][Dd]%]", date("%H:%M"))
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]%]", date("%m/%d/%y"))
		msg = gsub(msg, "%[[Dd][Aa][Tt][Ee]2%]", date("%Y.%m.%d"))
	end
	return msg
end

local function StopwatchStart()
	StopwatchFrame:Show()
	Stopwatch_Clear()
	Stopwatch_Play()
end

local function StopwatchEnd()
	Stopwatch_Clear()
	StopwatchFrame:Hide()
end

	-------------------------
	--- OnEvent Functions ---
	-------------------------

function KIT:CHAT_MSG_CHANNEL_NOTICE(event, msg)
	if msg == "YOU_CHANGED" then
		local instanceType = select(2, IsInInstance())
		if instanceType == "party" or instanceType == "raid" then
			-- 6 hours deadline
			if char.timeInstance == 0 or time() > char.timeInstance + 21600 then
				char.timeInstance, char.timeInstanceStart, char.timeInstanceStart2 = time(), date("%H:%M"), date("%Y.%m.%d |cffF6ADC6[%H:%M]|r")
				if (instanceType == "party" and profile.InstanceStopwatch) or (instanceType == "raid" and profile.RaidStopwatch) then
					StopwatchStart(); prevInst = instanceType
				end
			end
		elseif (instanceType == "pvp" or instanceType == "arena") and profile.BattlegroundStopwatch then
			StopwatchStart(); prevInst = instanceType
			-- delay registering for UPDATE_BATTLEFIELD_STATUS, because it also fires right after joining a battleground,
			-- and we're using that to see if the battleground has been finished
			self:ScheduleTimer(function()
				self:RegisterEvent("UPDATE_BATTLEFIELD_STATUS")
				-- "calibrate" the stopwatch
				StopwatchTicker.timer = GetBattlefieldInstanceRunTime() / 1000
			end, 10)
		elseif instanceType == "none" and char.timeInstance == 0 then
			lastTimeInst, lastTimeBG = nil, nil
			if (profile.InstanceStopwatch and prevInst == "party") or (profile.RaidStopwatch and prevInst == "raid") or (profile.BattlegroundStopwatch and (prevInst == "pvp" or prevInst == "arena")) then
				StopwatchEnd(); prevInst = nil
			end
		end
	end
end

function KIT:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, ...)
	if subevent == "UNIT_DIED" and tonumber(strsub(destGUID, 5, 5)) == 3 and (timeInstance2 or char.timeInstance) then
		local destNPC = tonumber(strsub(destGUID, 7, 10), 16)
		if BossIDs[destNPC] or RaidBossIDs[destNPC] then
			-- damn you, cookie!
			if destNPC == 47739 and GetInstanceDifficulty() == 2 then return end

			-- Record
			local subZone = SubZoneBossIDs[destNPC]
			if profile.RecordInstance then
				self:RecordInstance(subZone)
			end
			-- Announce
			if (profile.Instance and BossIDs[destNPC]) or (profile.Raid and RaidBossIDs[destNPC]) then
				self:AnnounceInstance(subZone)
			end
			-- Stopwatch
			local instanceType = select(2, IsInInstance())
			if (instanceType == "party" and profile.InstanceStopwatch) or (instanceType == "raid" and profile.RaidStopwatch) then
				Stopwatch_Pause()
			end

			-- pre-boss in a subzone
			if preBossIDs[destNPC] then
				timeInstance2 = char.timeInstance
			-- final boss in a subzone
			elseif finalBossIDs[destNPC] then
				timeInstance2 = 0
			end
			-- used to "pause" the LibDataBroker display 
			lastTimeInst = time() - (timeInstance2 or char.timeInstance)
			-- reset variables
			char.timeInstance, char.timeInstanceStart, char.timeInstanceStart2 = 0, "", ""
		end
	end
end

function KIT:CHAT_MSG_SYSTEM(event, msg)
	-- reset Instance Timer if left or kicked from group
	if msg == ERR_LEFT_GROUP_YOU or msg == ERR_UNINVITE_YOU then
		char.timeInstance, timeInstance2 = 0, nil
	end
end

function KIT:LFG_PROPOSAL_SUCCEEDED()
	self:ScheduleTimer(function()
		-- backup timer (30 sec) for if timeInstance is still nil
		if char.timeInstance == 0 then
			char.timeInstance = time()
			char.timeInstanceStart, char.timeInstanceStart2 = date("%H:%M"), date("%Y.%m.%d |cffF6ADC6[%H:%M]|r")
			if profile.InstanceStopwatch then
				StopwatchStart()
			end
		end
	end, 30)
end

-- only fires after completing a random dungeon
-- delay it a bit, so it doesn't react on the same time as boss death
function KIT:LFG_COMPLETION_REWARD()
	self:ScheduleTimer(function()
		if char.timeInstance > 0 then
			if profile.RecordInstance then
				self:RecordInstance()
			end
			if profile.Instance then
				self:AnnounceInstance()
			end
			if profile.InstanceStopwatch then
				Stopwatch_Pause()
			end
		end
		lastTimeInst = time() - (timeInstance2 or char.timeInstance)
		char.timeInstance, char.timeInstanceStart, char.timeInstanceStart2 = 0, "", ""
	end, 1)
end

function KIT:UPDATE_BATTLEFIELD_STATUS()
	local runTime = GetBattlefieldInstanceRunTime()
	if runTime and runTime > 0 then
		if profile.BattlegroundStopwatch then
			-- recalibrate timer and update the StopwatchFrame
			StopwatchTicker.timer = runTime / 1000
			StopwatchTicker_Update()
			Stopwatch_Pause()
		end
		lastTimeBG = runTime / 1000
		self:UnregisterEvent("UPDATE_BATTLEFIELD_STATUS")
	end
end